-- GNU GENERAL PUBLIC LICENSE Version 3
-- Created by Monk3yDev 
-- I will be so happy when this addon become popular.
-- If you want use code from DestroyusPro
-- please let me know about it monk3ydev at gmail dot com 


DestroyusPro = {}
local frame = CreateFrame("Frame", "DestroyusPro")
frame:RegisterEvent("ADDON_LOADED")


-- Milling --
local ClickMeForWorkMilling = CreateFrame("Button", "ClickMeForWorkMilling", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMilling:SetAttribute("type", "macro")
ClickMeForWorkMilling:SetAttribute("macrotext", "")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Disenchant --
local ClickMeForWorkDisenchanting = CreateFrame("Button", "ClickMeForWorkDisenchanting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkDisenchanting:SetAttribute("type", "macro")
ClickMeForWorkDisenchanting:SetAttribute("macrotext", "")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Prospecting --
local ClickMeForWorkProspecting = CreateFrame("Button", "ClickMeForWorkProspecting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkProspecting:SetAttribute("type", "macro")
ClickMeForWorkProspecting:SetAttribute("macrotext", "")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_ENABLED")

DestroyusPro.isInCombatMode = false -- change to local?

local function loadAddonData(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == 'DestroyusPro' then
		if _G["DestroyusProInitDataFirstLoad"] == nil then
			_G["DestroyusProInitDataFirstLoad"] = true
			_G["DestroyusProItemQualityValue"] = 2
		end
		local msg = "DestroyusPro Addon sucessfuly loaded. Quiality of items %s"
	    print(msg:format(DestroyusPro.numToStrQuality[_G["DestroyusProItemQualityValue"]]))
	end
end

local function combatMode(self, event, arg1)
	if event == "PLAYER_REGEN_DISABLED" then
		DestroyusPro.isInCombatMode = true
	end
	if event == "PLAYER_REGEN_ENABLED" then
		DestroyusPro.isInCombatMode = false
	end
end

local function preClickMacroButton(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Disenchant"))
	end
end

local function preClickMacroButtonMilling(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Milling"))
	end
end

local function preClickMacroButtonProspecting(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Prospecting"))
	end
end

local function postClickMacroButton(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonMilling(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonProspecting(self, event)
	if DestroyusPro.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

frame:SetScript("OnEvent", loadAddonData)
-- Set protection to do not create macro in combat
ClickMeForWorkDisenchanting:SetScript("OnEvent", combatMode)
ClickMeForWorkMilling:SetScript("OnEvent", combatMode)
ClickMeForWorkProspecting:SetScript("OnEvent", combatMode)

-- Create macro
ClickMeForWorkDisenchanting:SetScript("PreClick", preClickMacroButton)
ClickMeForWorkMilling:SetScript("PreClick", preClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PreClick", preClickMacroButtonProspecting)

-- Clear macro
ClickMeForWorkDisenchanting:SetScript("PostClick", postClickMacroButton)
ClickMeForWorkMilling:SetScript("PostClick", postClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PostClick", postClickMacroButtonProspecting)

function DestroyusPro.isItemDisenchantableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemDisenchantable(containerItemInfoTab["itemId"],
								             containerItemInfoTab["count"],
								             containerItemInfoTab["isNotSellable"])
end

function DestroyusPro.isItemMillingableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemMillingable(containerItemInfoTab["itemId"],
										  containerItemInfoTab["count"],
										  containerItemInfoTab["isNotSellable"])
end

function DestroyusPro.isItemProspectingableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemProspectingable(containerItemInfoTab["itemId"], 
								              containerItemInfoTab["count"],
								              containerItemInfoTab["isNotSellable"])
end

DestroyusPro.isItemProffesionInBag = {}
DestroyusPro.isItemProffesionInBag["Disenchant"] = DestroyusPro.isItemDisenchantableInBag
DestroyusPro.isItemProffesionInBag["Milling"] = DestroyusPro.isItemMillingableInBag
DestroyusPro.isItemProffesionInBag["Prospecting"] = DestroyusPro.isItemProspectingableInBag

function DestroyusPro.findItemToWork(proffesion)
    local result = {itemFound=false, i=0 ,j=0}
	for i=0,4 do 
		for j=1,GetContainerNumSlots(i) do 
			if DestroyusPro.isItemProffesionInBag[proffesion](i,j) then
			    local itemInfo = DestroyusPro.createContainerItemInfoTab(i,j)
				result["itemFound"] = true
				result["i"] = i
				result["j"] = j
				result["link"] = itemInfo["link"]
				result["itemId"] = itemInfo["itemId"]
				break
			end 
		end 
	end
	return result
end

-- Refactoring
-- Method should not print values 
-- Only return value 
function DestroyusPro.createMacroUsage(proffesion)
	local macroStr = '/cast '..proffesion..'\n/use %d %d'
	local result = DestroyusPro.findItemToWork(proffesion)
	if result["itemFound"] then
		macroStr = macroStr:format(result["i"], result["j"])
		print(""..proffesion.." => " .. result["link"] .. " ItemId: " .. result["itemId"])
	else
		macroStr = ""
		local msg = "Quiality of items %s"
		local informQualityDisenchant = proffesion == "Disenchant" and msg:format(DestroyusPro.numToStrQuality[_G["DestroyusProItemQualityValue"]]) or ""
		print("Nothing to "..proffesion.."!" .. " " .. informQualityDisenchant)
	end
	return macroStr
end


function DestroyusPro.isItemDisenchantable(itemId, _, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isItem(itemInfoTab["class"], itemInfoTab["subclass"], itemInfoTab["equipslot"]) and
	       DestroyusPro.isOnlyOneMaxStack(itemInfoTab["maxstack"]) and 
		   DestroyusPro.isNotUniqueItem(itemId, DestroyusPro.itemsIdNotForDisenchant) and
		   DestroyusPro.isQualityAllowed(itemInfoTab["quality"]) and
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.isItemEquippable(itemId) and
		   DestroyusPro.haveItemRequiredProfLvlDisenchant("Enchanting", itemInfoTab["ilevel"], itemInfoTab["quality"])
end

function DestroyusPro.isItemMillingable(itemId, count, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isHerb(itemInfoTab["class"], itemInfoTab["subclass"]) and 
		   DestroyusPro.isQualityHerbAllowed(itemInfoTab["quality"]) and
		   DestroyusPro.isItemNotConsumable(itemId) and 
		   DestroyusPro.isStackAmountEnough(count) and
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.isNotUniqueItem(itemId, DestroyusPro.itemsIdNotForMilling) and
		   DestroyusPro.haveItemRequiredProfLvl(itemInfoTab["name"], "Inscription", DestroyusPro.herbsIlvl)
end

function DestroyusPro.isItemProspectingable(itemId, count, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isOre(itemInfoTab["class"], itemInfoTab["subclass"], itemInfoTab["name"]) and
		   DestroyusPro.isItemNotConsumable(itemId) and 
		   DestroyusPro.isStackAmountEnough(count) and 
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.haveItemRequiredProfLvl(itemInfoTab["name"], "Jewelcrafting", DestroyusPro.oresIlvl)
end